<script setup lang="ts">
import { computed, ref } from 'vue'
import { usePromotionStore } from '../stores/promotion'
import { useProductStore } from '@/views/product/stores/product'
import { onMounted } from 'vue'
import type { Product } from '@/views/product/types/Product'

const promotionStore = usePromotionStore()
const productStore = useProductStore()
// const dateStore = useDatePickerStore()

// const datePickerDialog = ref(false)
const green = ref('sucess')
const red = ref('error')
const bakery = computed(() => productStore.bakery.map((item) => item.name))
const drink = computed(() => productStore.drink.map((item) => item.name))
const food = computed(() => productStore.food.map((item) => item.name))
const selectedProduct = ref<Product[]>([])
// const promotion = computed(() => promotionStore.getAll.map((item) => item.name))
onMounted(() => {
  productStore.getCategoryProducts()
  // promotionStore.getAll()
})
</script>

<template>
  <v-dialog v-model:model-value="promotionStore.dialog" style="width: 1000px">
    <v-card class="pa-5" title="Add Promotion">
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12" sm="12" md="4">
              <v-img
                :src="
                  'http://localhost:3000/images/promotions/' + promotionStore.promotionItem.image
                "
                width="200"
              ></v-img>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-file-input
                v-model="promotionStore.promotionItem.files"
                :rules="[
                  (value) => {
                    return (
                      !value ||
                      !value.length ||
                      value[0].size < 2000000 ||
                      'Image size should be less than 2 MB!'
                    )
                  }
                ]"
                accept="image/png, image/jpeg, image/bmp"
                placeholder="Pick an image"
                prepend-icon="mdi-image"
                label="Image"
              ></v-file-input>
            </v-col>

            <v-col cols="6">
              <v-text-field v-model="promotionStore.promotionItem.name" label="Name">
              </v-text-field>
            </v-col>

            <v-col cols="6">
              <v-text-field v-model="promotionStore.promotionItem.discount" label="Discount">
              </v-text-field>
            </v-col>

            <v-col cols="6">
              <v-textarea
                label="Description"
                v-model="promotionStore.promotionItem.description"
                row-height="25"
                rows="5"
                variant="outlined"
                auto-grow
                shaped
              ></v-textarea>
            </v-col>

            <v-col cols="6">
              <v-text-field v-model="promotionStore.promotionItem.startDate" label="Start Date">
              </v-text-field>
              <v-text-field v-model="promotionStore.promotionItem.endDate" label="End Date">
              </v-text-field>
              <!-- <v-menu max-width="290">
                <template #activator>
                  <v-text-field
                    v-model="promotionStore.promotionItem.startDate"
                    readonly
                    prepend-icon="mdi-calendar"
                    @click="openDatePickerDialog"
                    label="Start Date"
                  >
                  </v-text-field>
                  <date-picker-dialog
                    :dialog="datePickerDialog"
                    @getDialog="(newValue) => (datePickerDialog = newValue)"
                    @selectedDate="getSelectedDate"
                  />
                </template>
              </v-menu> -->

              <!-- <v-menu max-width="290">
                <template #activator>
                  <v-text-field
                    v-model="promotionStore.promotionItem.endDate"
                    readonly
                    prepend-icon="mdi-calendar"
                    @click="openDatePickerDialog"
                    label="End Date"
                  >
                  </v-text-field>
                  <date-picker-dialog
                    :dialog="datePickerDialog"
                    @getDialog="(newValue) => (datePickerDialog = newValue)"
                    @selectedDate="getSelectedDate"
                  />
                </template>
              </v-menu> -->
            </v-col>

            <v-col cols="3">
              <!-- <v-text-field v-model="promotionStore.promotionItem.description" label="Combo Set">
                    </v-text-field> -->
              <v-switch label="Combo Set" v-model="promotionStore.promotionItem.comboSet">
              </v-switch>
            </v-col>
            {{ promotionStore.promotionItem.usableProducts }}
            <v-col cols="3">
              <v-combobox
                label="Drink"
                clearable
                chips
                multiple
                v-model="promotionStore.selectedProduct"
                :items="productStore.drink"
                item-title="name"
                item-value="id"
                variant="outlined"
              ></v-combobox>
            </v-col>

            <v-col cols="3">
              <v-combobox
                label="Bakery"
                clearable
                chips
                multiple
                v-model="promotionStore.selectedProduct"
                :items="productStore.bakery"
                item-title="name"
                item-value="id"
                variant="outlined"
              ></v-combobox>
            </v-col>

            <v-col cols="3">
              <v-combobox
                label="Food"
                clearable
                chips
                multiple
                v-model="promotionStore.selectedProduct"
                :items="productStore.food"
                item-title="name"
                item-value="id"
                variant="outlined"
              ></v-combobox>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>

      <template #actions>
        <v-row justify="end">
          <v-btn @click="promotionStore.closeDialog()"> Cancel </v-btn>
          <v-btn @click="promotionStore.save()"> Save </v-btn>
        </v-row>
      </template>
    </v-card>
  </v-dialog>
</template>
